﻿using NUnit.Framework;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Searching;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.ViewModels;
using System;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Tests.Unit.Searching
{
    [TestFixture]
    public class CheckIdSearcherGeneratorTest
    {
        private CheckIdSearcherGenerator testee;


        [SetUp]
        public void SetUp()
        {
            this.testee = new CheckIdSearcherGenerator();
        }

        [Test]
        public void TestGenerate()
        {
            var searcher = this.testee.Generate("foo");
            Assert.IsTrue(searcher(new ProblemViewModel { CheckId = "Foo" }));
            Assert.IsTrue(searcher(new ProblemViewModel { CheckId = "xFoox" }));
            Assert.IsFalse(searcher(new ProblemViewModel { CheckId = "Bar" }));
            Assert.IsFalse(searcher(new ProblemViewModel { CheckId = "Fo" }));
        }
    }
}
