﻿using System;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Models
{
    public class Problem
    {
        public string CheckId { get; set; }

        public string Category { get; set; }

        public string Id { get; set; }

        public string Message { get; set; }

        public CodeKind Kind { get; set; }

        public string AssemblyPath { get; set; }

        public string ProjectName { get; set; }

        public string TypeName { get; set; }

        public string Path { get; set; }

        public string FileName { get { return System.IO.Path.GetFileName(Path); } }

        public int? Line { get; set; }



        /// <summary>
        /// Creates a new instance that is a deep copy of this instance.
        /// </summary>
        /// <returns>The deep copy of this instance.</returns>
        public Problem Copy()
        {
            Problem problem = new Problem();
            problem.CheckId = CheckId;
            problem.Category = Category;
            problem.Id = Id;
            problem.Message = Message;
            problem.Kind = Kind;
            problem.AssemblyPath = AssemblyPath;
            problem.ProjectName = ProjectName;
            problem.TypeName = TypeName;
            problem.Path = Path;
            problem.Line = Line;
            return problem;
        }
    }
}
