﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.ViewModels
{
    public class CodeAnalysisProgressViewModel : ViewModelBase
    {
        private Version fxcopVerison;


        public ICollection<CodeAnalysisViewModel> Analyses { get; private set; }

        public ICollection<ProblemViewModel> Problems { get; private set; }

        public ICollection<RuleViewModel> Rules { get; private set; }

        public Version FxCopVersion
        {
            get
            {
                return fxcopVerison;
            }
            set
            {
                fxcopVerison = value;
                OnPropertyChanged("FxCopVersion");
            }
        }


        public CodeAnalysisProgressViewModel()
        {
            Analyses = new ObservableCollection<CodeAnalysisViewModel>();
            Problems = new List<ProblemViewModel>();
            Rules = new List<RuleViewModel>();
        }
    }
}
