﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.Building;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Metrics;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Inspection;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands
{
    [MenuCommand(Constants.Project.Id, Constants.Project.Analyze)]
    public class AnalyzeProjectCommand : CodeAnalysisCommandBase
    {
        public AnalyzeProjectCommand(IUnityContainer container)
            : base(container)
        {
            if (ShouldCalculateMetrics())
            {
                Behaviors.Add(new ValidateMetricsAvailabilityBehavior(container));
            }
            if (ShouldInspect())
            {
                Behaviors.Add(new ValidateFxCopCmdAvailabilityBehavior(container));
            }

            Behaviors.Add(new BuildProjectBehavior(container));

            if (ShouldCalculateMetrics())
            {
                Behaviors.Add(new CreateProjectMetricsCalculatorBehavior(container));
            }
            if (ShouldInspect())
            {
                Behaviors.Add(new CreateProjectInspectorBehavior(container));
            }

            Behaviors.Add(new PerformCodeAnalysisBehavior(container));

            if (ShouldCalculateMetrics())
            {
                Behaviors.Add(new ShowCodeMetricsCalculationResultBehavior(container));
            }
            if (ShouldInspect())
            {
                Behaviors.Add(new ShowCodeInspectionResultBehavior(container));
            }
        }
    }
}
