﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.Building;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Inspection;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Metrics;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands
{
    [MenuCommand(Constants.Solution.Id, Constants.Solution.Analyze)]
    public class AnalyzeSolutionCommand : CodeAnalysisCommandBase
    {
        public AnalyzeSolutionCommand(IUnityContainer container)
            : base(container)
        {
            if (ShouldCalculateMetrics())
            {
                Behaviors.Add(new ValidateMetricsAvailabilityBehavior(container));
            }
            if (ShouldInspect())
            {
                Behaviors.Add(new ValidateFxCopCmdAvailabilityBehavior(container));
            }

            Behaviors.Add(new BuildSolutionBehavior(container));

            if (ShouldCalculateMetrics())
            {
                Behaviors.Add(new CreateSolutionMetricsCalculatorBehavior(container));
            }
            if (ShouldInspect())
            {
                Behaviors.Add(new CreateSolutionInspectorBehavior(container));
            }
            
            Behaviors.Add(new PerformCodeAnalysisBehavior(container));

            if (ShouldCalculateMetrics())
            {
                Behaviors.Add(new ShowCodeMetricsCalculationResultBehavior(container));
            }
            if (ShouldInspect())
            {
                Behaviors.Add(new ShowCodeInspectionResultBehavior(container));
            }
        }
    }
}
