﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.Core.VisualStudio;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.Building
{
    public class BuildSelectedProjectsBehavoir : ICommandBehavior<CodeAnalysisCommandExecutionContext>
    {
        private IUnityContainer container;


        public BuildSelectedProjectsBehavoir(IUnityContainer container)
        {
            this.container = container;
        }


        public void Behave(CodeAnalysisCommandExecutionContext context)
        {
            var ide = container.Resolve<IIde>();
            foreach (var project in ide.Solution.SelectedProjects)
            {
                if (!project.Build())
                {
                    context.Cancel("Stopped code analysis because build failed.", () => ide.ShowError());
                    return;
                }
            }
        }
    }
}
