﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.Building;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Metrics;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands
{
    [MenuCommand(Constants.Project.Id, Constants.Project.CalculateMetrics)]
    public class CalculateProjectMetricsCommand : CommandBase<CodeAnalysisCommandExecutionContext>
    {
        public CalculateProjectMetricsCommand(IUnityContainer container)
            : base(container)
        {
            Behaviors.Add(new ValidateMetricsAvailabilityBehavior(container));
            Behaviors.Add(new BuildProjectBehavior(container));
            Behaviors.Add(new CreateProjectMetricsCalculatorBehavior(container));
            Behaviors.Add(new PerformCodeAnalysisBehavior(container));
            Behaviors.Add(new ShowCodeMetricsCalculationResultBehavior(container));
        }
    }
}
