﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.Building;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Inspection;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands
{
    [MenuCommand(Constants.MultiProject.Id, Constants.MultiProject.Inspect)]
    public class InspectMultiProjectCommand : CommandBase<CodeAnalysisCommandExecutionContext>
    {
        public InspectMultiProjectCommand(IUnityContainer container)
            : base(container)
        {
            Behaviors.Add(new ValidateFxCopCmdAvailabilityBehavior(container));
            Behaviors.Add(new BuildSelectedProjectsBehavoir(container));
            Behaviors.Add(new CreateMultiProjectInspectorBehavior(container));
            Behaviors.Add(new PerformCodeAnalysisBehavior(container));
            Behaviors.Add(new ShowCodeInspectionResultBehavior(container));
        }
    }
}
