﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.Core.VisualStudio;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands
{
    [MenuCommand(Constants.Package.Id, Constants.Package.ShowCodeMetricsCalculationResult)]
    public class ShowCodeMetricsCalculationResultCommand : CommandBase<CommandExecutionContext>, ICommandBehavior<CommandExecutionContext>
    {
        public ShowCodeMetricsCalculationResultCommand(IUnityContainer container)
            : base(container)
        {
            Behaviors.Add(this);
        }

        public void Behave(CommandExecutionContext context)
        {
            var ide = Container.Resolve<IIde>();
            ide.FindCodeMetricsCalculationResultView().Show();
        }
    }
}
