﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.Core.VisualStudio;
using System.Linq;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.Building
{
    public class BuildItemContainingProjectBehavior : ICommandBehavior<CodeAnalysisCommandExecutionContext>
    {
        private IUnityContainer container;


        public BuildItemContainingProjectBehavior(IUnityContainer container)
        {
            this.container = container;
        }


        public void Behave(CodeAnalysisCommandExecutionContext context)
        {
            var ide = container.Resolve<IIde>();
            var project = ide.SelectedProjectItems.ElementAt(0).ContainingProject;

            if (!project.Build())
            {
                context.Cancel("Stopped code analysis because build failed.", () => ide.ShowError());
                return;
            }
        }
    }
}
