﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Unity;
using System.IO;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Inspection
{
    public class ValidateFxCopCmdAvailabilityBehavior : ICommandBehavior<CodeAnalysisCommandExecutionContext>
    {
        private IUnityContainer container;


        public ValidateFxCopCmdAvailabilityBehavior(IUnityContainer container)
        {
            this.container = container;
        }


        public void Behave(CodeAnalysisCommandExecutionContext context)
        {
            var package = container.Resolve<IFxCopIntegratorPackage>();
            var option = package.GeneralOption;

            if (!File.Exists(option.FxCopCmdPath))
            {
                context.Cancel("FxCop Integrator didn't perform code analysis because it couldn't find FxCopCmd.exe.", () => container.Resolve<IFxCopIntegratorPackage>().ShowGeneralOptionDialog());
                return;
            }

            context.Progress.FxCopVersion = option.FxCopVersion;
        }
    }
}
