﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.Building;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Metrics;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands
{
    [MenuCommand(Constants.MultiProject.Id, Constants.MultiProject.CalculateMetrics)]
    public class CalculateMultiProjectMetricsCommand : CommandBase<CodeAnalysisCommandExecutionContext>
    {
        public CalculateMultiProjectMetricsCommand(IUnityContainer container)
            : base(container)
        {
            Behaviors.Add(new ValidateMetricsAvailabilityBehavior(container));
            Behaviors.Add(new BuildSelectedProjectsBehavoir(container));
            Behaviors.Add(new CreateMultiProjectMetricsCalculatorBehavior(container));
            Behaviors.Add(new PerformCodeAnalysisBehavior(container));
            Behaviors.Add(new ShowCodeMetricsCalculationResultBehavior(container));
        }
    }
}
