﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.Building;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Inspection;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands
{
    [MenuCommand(Constants.Project.Id, Constants.Project.Inspect)]
    public class InspectProjectCommand : CommandBase<CodeAnalysisCommandExecutionContext>
    {
        public InspectProjectCommand(IUnityContainer container)
            : base(container)
        {
            Behaviors.Add(new ValidateFxCopCmdAvailabilityBehavior(container));
            Behaviors.Add(new BuildProjectBehavior(container));
            Behaviors.Add(new CreateProjectInspectorBehavior(container));
            Behaviors.Add(new PerformCodeAnalysisBehavior(container));
            Behaviors.Add(new ShowCodeInspectionResultBehavior(container));
        }
    }
}
