﻿using Microsoft.Practices.Unity;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.Building;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis;
using Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands.Behaviors.CodeAnalysis.Inspection;

namespace Sasa.QualityTools.CodeAnalysis.FxCopIntegrator.Commands
{
    [MenuCommand(Constants.Solution.Id, Constants.Solution.Inspect)]
    public class InspectSolutionCommand : CommandBase<CodeAnalysisCommandExecutionContext>
    {
        public InspectSolutionCommand(IUnityContainer container)
            : base(container)
        {
            Behaviors.Add(new ValidateFxCopCmdAvailabilityBehavior(container));
            Behaviors.Add(new BuildSolutionBehavior(container));
            Behaviors.Add(new CreateSolutionInspectorBehavior(container));
            Behaviors.Add(new PerformCodeAnalysisBehavior(container));
            Behaviors.Add(new ShowCodeInspectionResultBehavior(container));
        }
    }
}
